## CLAM-r15456.tar.xz

=== SConstruct ===
#!/usr/bin/python
EnsureSConsVersion(0, 96, 92)
import sys
import os
import glob

sys.path.append( os.path.abspath("scons/libs/") )
from clam_build_helpers import *
from clam_dependent_libs_checks import *

# crosscompiling option is one option we should know on beforehand
crosscompiling = False
if sys.platform == 'linux2' :
	opts = Variables('options.cache',ARGUMENTS)
	opts.Add( BoolVariable( 'crossmingw', '', 'no' ))
	crosscompiling = Environment(options=opts)['crossmingw']
	if crosscompiling : print "Warning: Crosscompiling mode"

isWindowsPlatform = sys.platform=='win32' or crosscompiling
isLinuxPlatform = sys.platform=='linux2' and not crosscompiling
isDarwinPlatform = sys.platform=='darwin'

def load_config_file_to_env( env, dir ):
	opts = Variables(dir+'/flags.conf')
	opts.Add( 'CPPPATH', 'CPP PATH')
	opts.Add( 'CCFLAGS', 'CC FLAGS')
	opts.Add( 'CPPFLAGS', 'CPP FLAGS')
	opts.Add( 'LIBPATH', 'LIB PATH')
	opts.Add( 'LIBS', 'libs to link')
	opts.Add( 'LINKFLAGS', 'LINKFLAGS') # This one added because on Mac OS X we need additional '-framework OpenGL && AGL'
	opts.Add( 'pkg_config_available', 'PKG Config Available', 'False')
	opts.Update(env)

def save_config_file_from_env( env, dir ):
	# workaround due to bug in scons (if we add the flag after loading it will add "" to the new flagand will fail
	opts = Variables()
	opts.Add( 'CPPPATH', 'CPP PATH', '')
	opts.Add( 'CCFLAGS', 'CC FLAGS', '')
	opts.Add( 'CPPFLAGS', 'CPP FLAGS', '')
	opts.Add( 'LIBPATH', 'LIB PATH', '')
	opts.Add( 'LIBS', 'libs to link', env['LIBS'])
	opts.Add( 'LINKFLAGS', 'LINKFLAGS', '') # This one added because on Mac OS X we need additional '-framework OpenGL && AGL'
	opts.Add( 'pkg_config_available', 'PKG Config Available', 'False')
	opts.Save(dir+'/flags.conf', env)

def configure_clam(clam_env) :
	print """\
############################################
### CLAM GLOBAL DEPENDENCIES CHECKING    ###
############################################"""
	# Sandbox setup
	if isWindowsPlatform :
		clam_env.AppendUnique( CPPPATH = [os.path.join(clam_env['sandbox_path'], 'local', 'include')] )
		clam_env.AppendUnique( LIBPATH = [os.path.join(clam_env['sandbox_path'], 'local', 'lib')] )
		if os.environ.has_key('INCLUDE') :
			for include in os.environ['INCLUDE'].split(';') :
				if not include : continue
				print( 'adding include dir from windows config: ' + include )
				clam_env.AppendUnique( CPPPATH = [include] )
	if isLinuxPlatform :
		clam_env.AppendUnique( CPPPATH= ['/usr/local/include'] )
	if isDarwinPlatform :
		clam_env.AppendUnique( CPPPATH= ['/usr/local/include', '/opt/local/include'] )


	conf = Configure( clam_env, custom_tests = custom_check_routines )
	if not setup_global_environment( clam_env, conf ) :
		Exit(1)
	clam_env = conf.Finish()

def configure_core(clam_env) :
	print """\
#########################################
### CLAM CORE DEPENDENCIES CHECKING   ###
#########################################"""
	core_env = clam_env.Clone()
	conf = Configure( core_env, custom_tests = custom_check_routines )
	if not setup_core_environment( core_env, conf ) :
		Exit(1)
	core_env = conf.Finish()
	clam_env['xmlbackend'] = core_env['xmlbackend']
	return core_env

def configure_processing(core_env) :
	print """\
###############################################
### CLAM PROCESSING DEPENDENCIES CHECKING   ###
###############################################"""
	processing_env = core_env.Clone()
	conf = Configure( processing_env, custom_check_routines )
	if not setup_processing_environment( processing_env, conf ) :
		Exit(1)
	processing_env = conf.Finish()
	return processing_env

def configure_audioio(processing_env) :
	print """\
############################################
### CLAM AUDIOIO DEPENDENCIES CHECKING   ###
############################################"""
	audioio_env = processing_env.Clone()

	conf = Configure( audioio_env, custom_check_routines )
	if not setup_audioio_environment( audioio_env, conf ) :
		Exit(1)
	audioio_env = conf.Finish()
	return audioio_env

def configureModules( clam_env ) :
	configure_clam(clam_env)
	save_config_file_from_env(clam_env, 'scons/libs')
	core_env = configure_core(clam_env)
	save_config_file_from_env(core_env, 'scons/libs/core')
	processing_env = configure_processing(core_env)
	save_config_file_from_env(processing_env, 'scons/libs/processing')
	audioio_env = configure_audioio(core_env)
	save_config_file_from_env(audioio_env, 'scons/libs/audioio')

# helper functions
def setup_build_options( env ) :
	# configuration options:
	opts = Variables('options.cache')
	
	# global options
	opts.Add( PathVariable( 'prefix', 'Install location for CLAM', '/usr/local'))
	opts.Add( PathVariable( 'prefix_for_packaging', 'Install location when packaging (just for .deb creation)', '.'))
	if isWindowsPlatform :
		opts.Add( PathVariable( 'sandbox_path', 'The working directory in mingw where the external libraries are placed', '' ) )
	opts.Add( BoolVariable( 'release', 'Build CLAM with optimizations and stripping debug symbols', 'no'))
	opts.Add( BoolVariable( 'checks', 'Postcondition checks enabled', 'yes' ))
	opts.Add( BoolVariable( 'intel_optimize', 'Build CLAM with newer intel specific optimizations', 'no'))
	opts.Add( BoolVariable( 'double', 'CLAM TData type will be double instead of float','no'))
	if sys.platform == "linux2" :
		opts.Add( BoolVariable( 'crossmingw', '', 'no' ))

	opts.Add( BoolVariable( 'verbose', 'Display commands', False) )
	opts.Add( BoolVariable( 'release_asserts', 'CLAM asserts will be triggered on release builds', 'no'))
	opts.Add( BoolVariable( 'optimize_and_lose_precision', 'Use tabulated trigonometric functions and the like', 'no' )) 
	opts.Add( BoolVariable( 'force_avoid_configure', 'Avoid configure phase. Useful for Eclipse scons plugin. Enable it only if you know what you are doing', 'no' ) )
	opts.Add( 'distcc_hosts', 'Defines compiling hosts, if defined enables the distcc compiler', '')
	
	# clam_core options
	opts.Add( EnumVariable( 'xmlbackend', 'XML passivation backend', 'xercesc', ('xercesc','xmlpp','both','none')) )
	if not isWindowsPlatform :
		opts.Add( BoolVariable( 'with_jack', 'Enables/Disable JACK support', 'yes') )
	else :
		opts.Add( BoolVariable( 'with_jack', 'Enables/Disable JACK support', 'no') )

	opts.Add( BoolVariable( 'with_ladspa', 'Ladspa plugin support', True) )
	opts.Add( BoolVariable( 'with_lv2', 'Lv2 plugin support', True) )
	
	# clam_processing options
	opts.Add( BoolVariable( 'with_fftw3', 'Selects whether to use fftw3 or not', 'yes'))
	opts.Add( BoolVariable( 'with_nr_fft', 'Selects whether to use Numerical Recipes fft algorithm implementation or not', 'yes') )

	# clam_audioio options
	opts.Add( BoolVariable( 'with_sndfile', 'Enables PCM files reading and writing', 'yes' ) )	
	opts.Add( BoolVariable( 'with_oggvorbis', 'Enables ogg/vorbis reading and writing support', 'yes' ) )
	opts.Add( BoolVariable( 'with_mad', 'Enables mpeg 1 layer 3 files reading and writing support', 'yes' ) )
	opts.Add( BoolVariable( 'with_id3', 'Enables support for accesing ID3 tags on mpeg audio streams', 'yes') )
	opts.Add( BoolVariable( 'with_portaudio', 'Enables audio device I/O using PortAudio', 'yes') )
	if isLinuxPlatform :
		opts.Add( BoolVariable( 'with_alsa', 'Enables PCM and MIDI device I/O through ALSA', 'yes' ) )
	elif isDarwinPlatform :
		opts.Add( EnumVariable( 'audio_backend', 'Selects audio PCM i/o library used by CLAM backend', 'rtaudio', ('rtaudio','portaudio') ) )
	elif isWindowsPlatform :
		opts.Add( EnumVariable( 'audio_backend', 'Selects audio PCM i/o library used by CLAM backend', 'rtaudio', ('rtaudio','directx','portaudio') ) )
	opts.Add( BoolVariable( 'with_portmidi', 'Enables MIDI device I/O through portmidi', 'no' ) )

	opts.Update(env)
	opts.Save('options.cache', env) # Save, so user doesn't have to 
	  				# specify prefix and other options every time

	Help("""
configure : Configures clam libraries. This is a mandatory step
""" + opts.GenerateHelpText(env) )

def compose_install_dirnames( env ) :
	install_dirs = InstallDirs(env)
	print """\
#############################################
### INSTALL DIRECTORY INFORMATION         ###
#############################################"""
	print "Directory to install under:", install_dirs.prefix
	print "\tLibrary files will be installed at:", install_dirs.lib
	print "\tExecutable files will be installed at:", install_dirs.bin
	print "\tInclude files will be installed at:", install_dirs.inc
	print "\tDocumentation, data and examples will be installed at:", install_dirs.data
	return install_dirs



def config_file_missing():
	dirs = ". core audioio processing"
	files = [ "scons/libs/"+dir+"/flags.conf" for dir in dirs.split()]
	func_and = lambda x,y : x and y
	result = not reduce( func_and, map(os.path.exists, files) ) 

#	if result == False:
#		print "\n WARNING: at least one module configuration file is missing. Running automatically as a 'scons configure'\n"

	return result



# SConstruct file for CLAM
# Main section

toolChain = 'default'
if sys.platform == "win32": toolChain = 'mingw'
clam_env = Environment( ENV=os.environ, tools=[toolChain])
clam_env.SConsignFile()
# scons optimizations
clam_env.Decider('MD5-timestamp') # do not MD5 if the dates don't differ
clam_env.SetOption('max_drift', 60) # just 60 seconds of clock drift
clam_env.SetOption('implicit_cache', 1)
setup_build_options( clam_env )
SetupSpawn(clam_env) # to solve long command line problems (in win32)

if not clam_env['verbose']:
	clam_env['CXXCOMSTR'] = '== Compiling $SOURCE'
	clam_env['SHCXXCOMSTR'] = '== Compiling shared $SOURCE'
	clam_env['LINKCOMSTR'] = '== Linking $TARGET'
	clam_env['SHLINKCOMSTR'] = '== Linking library $TARGET'

crosscompiling = clam_env.has_key('crossmingw') and clam_env['crossmingw']
if crosscompiling :
	clam_env.Tool('crossmingw',toolpath=['scons/sconstools'])

clam_env.Tool('textfile',toolpath=['scons/sconstools'])
clam_env.Tool('pc',toolpath=['scons/sconstools'])

if clam_env['distcc_hosts'] :
	clam_env['CXX'] = 'distcc '+clam_env['CXX']
	clam_env['ENV']['DISTCC_HOSTS'] = clam_env['distcc_hosts']
	SetOption('num_jobs', len( clam_env['distcc_hosts'].split() ))


sys.path.append('scons/sconstools')
import versionInfo
version, fullVersion = versionInfo.versionFromLocalInfo("CLAM", "CHANGES")
Export('version')
print "Version: ", version
print "Package version: ", fullVersion


versionInfo.generateVersionSources(os.path.join('src','Defines','CLAMVersion'), "CLAM", version, fullVersion)

Export('clam_env')

#registering custom checks
custom_check_routines = dict()
custom_check_routines.update(package_checks)
custom_check_routines.update(tool_checks)
custom_check_routines.update(generic_checks)
custom_check_routines['CheckPkgConfigFile']=CheckPkgConfigFile
custom_check_routines['CheckLibrarySample']=CheckLibrarySample

#registering custom_builders
create_custom_builders(clam_env)

clam_env['CXXFILESUFFIX'] = '.cxx'

#needs configure?
avoid_configure_option=ARGUMENTS.get('force_avoid_configure',0)
needs_configure = ('configure' in COMMAND_LINE_TARGETS) or config_file_missing() or len(ARGUMENTS)>0
avoid_configure = '--help' in COMMAND_LINE_TARGETS or avoid_configure_option=='1' or avoid_configure_option=='yes' or '-c' in ARGUMENTS

if needs_configure and not avoid_configure :
	print 'Configure phase...'
	configureModules(clam_env)
	print "Finished. Invoke 'scons' now."
	Exit(0)


core_env = clam_env.Clone()
processing_env = clam_env.Clone()
audioio_env = clam_env.Clone()

modules = [ 'core', 'processing', 'audioio']

Export("crosscompiling")

# install dirs composition
install_dirs = compose_install_dirnames(clam_env)
Export('install_dirs')

#building
if not clam_env.GetOption('clean') :
	for module in modules :
		load_config_file_to_env(eval(module+'_env'), 'scons/libs/'+module)

for module in modules :
	Export(module+'_env')
	SConscript('scons/libs/'+module+'/SConscript')

doxygen = clam_env.Command("DoxyLog", "doxygen.cfg",

=== examples/SConstruct ===
#!/usr/bin/python
import os
import glob
import sys

options = Variables('options.cache', ARGUMENTS)
options.Add(PathVariable('clam_prefix', 'The prefix where CLAM was installed', ''))
options.Add(BoolVariable('verbose', 'Display the full command line instead a short command description', 'no') )
options.Add(BoolVariable('crossmingw', 'Enables MinGW crosscompilation from linux', 'no') )

def scanFiles(pattern, paths) :
	files = []
	for path in paths :
		files+=glob.glob(path+"/"+pattern)
	return files

def recursiveDirs(root) :
	return filter( (lambda a : a.rfind( ".svn")==-1 ),  [ a[0] for a in os.walk(root)]  )

def unique(list) :
	return dict.fromkeys(list).keys()



toolchain = 'default'
if sys.platform == "win32" : toolchain = 'mingw'
env = Environment(tools=[toolchain], options=options)
options.Save('options.cache', env)

#TODO: This didn't work for dynamic linking

def renameEmbededFileSymbols(source, target, env) :
	""" Remove the path part of the symbol name for the embeded file"""
	objdumpOutput=os.popen("objdump -x %s | grep _binary'.*'start"%target[0] , "r").read()
	startSymbol=objdumpOutput.split()[-1]
	infix = startSymbol[len('_binary_'):-len("_start")]
	baseName = os.path.split(str(source[0]))[-1]
	newInfix = infix[-len(baseName):]
	return Execute("objcopy %(target)s "
		"--redefine-sym _binary_%(infix)s_start=_binary_%(newInfix)s_start "
		"--redefine-sym _binary_%(infix)s_end=_binary_%(newInfix)s_end "
		"--redefine-sym _binary_%(infix)s_size=_binary_%(newInfix)s_size " % {
			"infix": infix,
			"newInfix": newInfix,
			"target": target[0],
		}
	)
"""
embededFileBuilder = Builder(
	action=Action([
		["ld", "-fPIC", "--shared", "-b", "binary", "-o", "$TARGET", "$SOURCE"],
		renameEmbededFileSymbols,
		],
		),
	suffix='.os',
	)
env['BUILDERS']['EmbededFile']=embededFileBuilder
"""

env.SConsignFile() # Single signature file

crosscompiling=env['crossmingw']

CLAMInstallDir = env['clam_prefix']
clam_sconstoolspath = os.path.join(CLAMInstallDir,'share','clam','sconstools')
env.Tool('clam', toolpath=[clam_sconstoolspath])
env.Tool('qt4', toolpath=[clam_sconstoolspath])
if crosscompiling :
	env.Tool('crossmingw', toolpath=[clam_sconstoolspath])

env.AppendUnique(ASFLAGS='-I. ')

env['CXXFILESUFFIX'] = '.cxx'
env['QT4_UICDECLSUFFIX'] = '.hxx'
env.moveIntermediateInto('generated')
env.activateColorCommandLine()
if not env['verbose']: env.ClamQuietCompilation()

env.EnableClamModules(libs=[
	'clam_core',
	'clam_audioio',
	'clam_processing',
	], path=CLAMInstallDir)

env.EnableQt4Modules([
	'QtCore',
	'QtGui',
	'QtOpenGL',
#	'QtSql',
#	'QtNetwork',
#	'QtTest',
#	'QtXml',
#	'QtSvg',
#	'QtUiTools',
#	'QtDesigner',
#	'Qt3Support',
	], debug=False,
	crosscompiling=crosscompiling,
	)


sourcePaths = []
extraPaths = [
	CLAMInstallDir+'/include',
	CLAMInstallDir+'/include/CLAM', # KLUDGE to keep old style includes
]
includePaths = sourcePaths + extraPaths

sources = scanFiles('*.cxx', sourcePaths)
sources = unique(sources)


singleSourceExamples = [
	"WritingProcessings.cxx",
	"NetworkPersistence_example.cxx",
	"NetworkUsage_example.cxx",
	"AudioFileReading_example.cxx",
	"AudioFileWriting_example.cxx",
	"AudioIOExample.cxx",
#	"Configurators_example.cxx", # QT4Port
	"DescriptorComputation_example.cxx",
	"FDFilterExample.cxx",
	"FFT_example.cxx",
	"FileInfo_example.cxx",
	"FilePlayback_example.cxx",
	"FundamentalDetect.cxx",
	"LPCAnalysis_example.cxx", # TODO FLTK Dependencies -> Qt4
	"Midi2XmlExample.cxx",
	"MIDIFileReadWriteExample.cxx",
	"MIDIIOExample.cxx",
	"MIDIOut_example.cxx",
	"MIDI_Synthesizer_example.cxx",
	"NetworkPersistence_example.cxx",
	"NetworkUsage_example.cxx",
	"OfflineAudioConvolution.cxx",
	"PersistenceThroughDTs_example.cxx",
	"POCompositeExample.cxx",
	"SimplePortsUsage_example.cxx",
	"ProcessingLifeCycle_example.cxx",
	"ProcessingObject_controls_example.cxx",
	"SDIF_And_Segment_example.cxx", # TODO: FLTK Dependencies
	"Spectrum_example.cxx",
	"StereoToMonoFile.cxx",
#	"ThreadedProcessing_example.cxx", # TODO: Depends on Resample and FLTK
	"Tutorial/UserTutorial1.cxx",
	"Tutorial/UserTutorial2.cxx",
	"Tutorial/UserTutorial3.cxx",
	"Tutorial/UserTutorial4.cxx",
	"Tutorial/UserTutorial5.cxx",
	"Tutorial/UserTutorial6.cxx",
]


directoryBasedExamples = [
	"PortsAndControlsUsageExample",
	"ControlArrayExamples",
	"Wav2SDIF",
	"SDIF2Wav",
	"SDIF2WavStreaming",
]

directoryBasedLibraries = [
#	"PluginExamples/ClamLadspaPluginExample",
	"PluginExamples/ClamNativePluginExample",
]

singleSourceLibraries = [
]

env.Append(CPPPATH=includePaths)
env.AppendUnique(CPPFLAGS=["-g", "-Wall"])
#env.AppendUnique(DEFINES=["_DEBUG"])

examples = []

for libsource in singleSourceLibraries :
	library = os.path.basename(libsource)
	examples += [ env.SharedLibrary(source = libsource ) ]

for folder in directoryBasedLibraries :
	librarySources = glob.glob(folder+"/*.cxx")
#	librarySources += [env.EmbededFile(file) for file in glob.glob(folder+"/*.clamnetwork")]
	library = os.path.basename(folder)
	examples += [ env.SharedLibrary(target=library, source = librarySources ) ]

for main in singleSourceExamples :
	executable = os.path.splitext(os.path.basename(main))[0]
	examples += [ env.Program(target=executable, source = sources + [main] ) ]

for folder in directoryBasedExamples :
	exampleSources = glob.glob(folder+"/*.cxx")
	executable = os.path.basename(folder)+"Exe"
	examples += [ env.Program(target=executable, source = sources + exampleSources ) ]

if not crosscompiling :
	# Still having problems crosscompiling aubio
	tickEnv = env.Clone()
	tickEnv.ParseConfig('pkg-config aubio --cflags --libs')
	tickEnv.ParseConfig('pkg-config samplerate --cflags --libs')
	tickSrc = glob.glob("TickExtractor/*cxx")
	examples += [ tickEnv.Program(target="TickExtractorExe", source = tickSrc) ]

env.Alias('examples',examples)

env.Default(examples)

=== test/SConstruct ===
#!/usr/bin/python
import sys, os

# CLAM unit tests build

clamToolPath="../scons/sconstools"

options = Variables('options.cache')

options.Add( PathVariable( 'clam_prefix', 'Prefix were CLAM was installed', '') )
options.Add( PathVariable( 'prefix', 'Prefix were CLAM was installed', '/usr/local') )
options.Add( BoolVariable( 'release', 'Build CLAM Tests enabling compiler optimizations', 'no') )
options.Add( PathVariable( 'test_data_path', 'Path to the TestDataPrefix', '') )

options.Add(BoolVariable('crossmingw', 'Using MinGW crosscompiler mode in linux', 'no') )
options.Add(BoolVariable('verbose', 'Display the full command line instead a short command description', 'no') )

toolchain='default'
if sys.platform == 'win32': toolchain = 'mingw'
env = Environment(ENV=os.environ, tools=[toolchain], options=options)
env.Tool('clam', toolpath=[clamToolPath])

options.Update(env)
options.Save('options.cache', env)
Help(options.GenerateHelpText(env))

env.SConsignFile() # Single signature file

env['project'] = 'CLAMTests'
env['CXXFILESUFFIX'] = '.cxx'
env['QT4_UICDECLSUFFIX'] = '.hxx'
env.moveIntermediateInto('generated')
env.activateColorCommandLine()
if not env['verbose']: env.ClamQuietCompilation()


crosscompiling = env["crossmingw"]
if crosscompiling :
	env.Tool('crossmingw', toolpath=[clamToolPath])

env.moveIntermediateInto('generated')
env.activateColorCommandLine()
if not env['verbose']: env.ClamQuietCompilation()

env.EnableClamModules([
	'clam_core',
	'clam_audioio',
	'clam_processing'
	], env['clam_prefix'] )

env.ParseConfig( 'pkg-config --cflags --libs cppunit xerces-c libxml++-2.6')

env.Append( CPPFLAGS = ['-DTEST_DATA_PATH="\\"%s\\""' % env['test_data_path'] ] )
env.Append( CPPFLAGS = ['-DCLAM_MODULE="\\"tests\\""'] )

if sys.platform == 'darwin':
	env.AppendUnique( LIBS=['xerces-c'] )
	env.AppendUnique( LIBPATH=['/opt/local/lib'] )

#TODO: KLUDGE to allow old style and new style CLAM headers
env.Append(CPPPATH=env['clam_prefix']+'/include/CLAM')
env.Append(CPPPATH=env['clam_prefix']+'/include')
env.Append(CPPPATH=['include'])
env.Append(CPPPATH=os.path.join('..','UnitTests', 'CommonHelpers'))
env.Append(CPPPATH=os.path.join('..','UnitTests'))
env.Append(CPPPATH=os.path.join('..','FunctionalTests','CommonHelpers'))

Export( 'env' )
SConscript('UnitTests/SConscript')
SConscript('FunctionalTests/SConscript')

Alias( 'all', ['run_unit_tests','run_functional_tests'] )

=== plugins/Filters/SConstruct ===
#!/usr/bin/env python
import os, glob, sys

moduleName='filterspkg'
version = "1.4.0"
description = "FIR for the CLAM framework"
url = 'http://clam-project.org'
clamDependencies = [
	'clam_core',
	]
otherDependencies = [
	]

options = Variables('options.cache', ARGUMENTS)
options.Add(PathVariable('clam_prefix', 'The prefix where CLAM was installed', '/usr/local'))
options.Add(BoolVariable('verbose', 'Display the full command line', 'no') )
options.Add(PathVariable('prefix', 'Installation prefix (normally /usr, by default this is clam_prefix)', "", validator=PathVariable.PathAccept))
options.Add(PathVariable('prefix_for_packaging', 'Install location when packaging. Use "." for same as prefix.', '.'))
options.Add(BoolVariable('crossmingw', 'Using MinGW crosscompiler mode', 'no') )

toolChain = 'default'
if sys.platform == "win32": toolChain = 'mingw'
env = Environment(ENV=os.environ, tools=[toolChain], options=options)
options.Save('options.cache', env)
Help(options.GenerateHelpText(env))
env.SConsignFile() # Single signature file

CLAMInstallDir = env['clam_prefix']
if not env['prefix'] : env['prefix'] = env['clam_prefix']
#TODO: CHECK THIS
if env['prefix_for_packaging'] == '.' : env['prefix_for_packaging'] = env['prefix']

clam_sconstoolspath = os.path.join(CLAMInstallDir,'share','clam','sconstools')
if not os.access(os.path.join(clam_sconstoolspath,"clam.py"),os.R_OK):
	raise Exception("CLAM not installed at '%s'. Use clam_prefix option."%CLAMInstallDir)
if env['crossmingw'] :
	env.Tool('crossmingw', toolpath=[clam_sconstoolspath])
env.Tool('clam', toolpath=[clam_sconstoolspath])
env.EnableClamModules(clamDependencies, CLAMInstallDir)

# Sources and headers
sourcePaths = env.recursiveDirs(".")
sources = env.scanFiles('*.cxx', sourcePaths)
headers = env.scanFiles('*.hxx', sourcePaths)
env.AppendUnique(CPPPATH=sourcePaths)
env.Append( CCFLAGS=['-g','-O3','-Wall'] )

install, default = env.ClamModule(
	moduleName,
	version,
	description = description,
	url = url,
	sources = sources,
	headers = headers,
	clamDependencies = clamDependencies,
	otherDependencies = otherDependencies,
	)

env.Alias('install', install)
env.Default(default)

=== plugins/GuitarEffects/SConstruct ===
#! /usr/bin/python
import os, glob, sys

moduleName='guitareffects'
version = "1.4.0"
description = "Guitar effects for the CLAM framework"
url = 'http://clam-project.org'
clamDependencies = [
	'clam_core',
	'clam_audioio',
	'clam_processing',
	]
otherDependencies = [
	]
libPaths = [
	('guitardistortion', 'GuitarDistortion'),
	('zyndistortion', 'ZynDistortion'),
	('dcremoval', 'DCRemoval'),
	('audioswitch', 'AudioSwitch'),
	('automaticgaincontrol', 'AutomaticGainControl'),
	('timedelay', 'TimeDelay'),
	('audionormalization', 'AudioNormalization'),
	('clipping', 'Clipping'),
]

options = Variables('options.cache', ARGUMENTS)
options.Add(PathVariable('clam_prefix', 'The prefix where CLAM was installed', '/usr/local'))
options.Add(BoolVariable('verbose', 'Display the full command line', 'no') )
options.Add(PathVariable('prefix', 'Installation prefix (normally /usr, by default this is clam_prefix)', "", validator=PathVariable.PathAccept))
options.Add(PathVariable('prefix_for_packaging', 'Install location when packaging. Use "." for same as prefix.', '.'))
options.Add(BoolVariable('crossmingw', 'Using MinGW crosscompiler mode', 'no') )

toolChain = 'default'
if sys.platform == "win32": toolChain = 'mingw'
env = Environment(ENV=os.environ, tools=[toolChain], options=options)
options.Save('options.cache', env)
Help(options.GenerateHelpText(env))
env.SConsignFile() # Single signature file

CLAMInstallDir = env['clam_prefix']
if not env['prefix'] : env['prefix'] = env['clam_prefix']
#TODO: CHECK THIS
if env['prefix_for_packaging'] == '.' : env['prefix_for_packaging'] = env['prefix']

clam_sconstoolspath = os.path.join(CLAMInstallDir,'share','clam','sconstools')
if not os.access(os.path.join(clam_sconstoolspath,"clam.py"),os.R_OK):
	raise Exception("CLAM not installed at '%s'. Use clam_prefix option."%CLAMInstallDir)
if env['crossmingw'] :
	env.Tool('crossmingw', toolpath=[clam_sconstoolspath])
env.Tool('clam', toolpath=[clam_sconstoolspath])
env.EnableClamModules(clamDependencies, CLAMInstallDir)

examples = [
	'Dist1-rack.ui',
	'Dist1.clamnetwork',
	'TestAll.clamnetwork',
	'SimpleDistortionNetwork.clamnetwork',
	]
dirs = sum((
	env.recursiveDirs(dir)
	for libraryName, dir in libPaths
	),[])

env.Append( CCFLAGS=['-g','-O3','-Wall'] )

install, default = env.ClamModule(
	moduleName,
	version,
	description = description,
	url = url,
	sources = env.scanFiles("*.cxx", dirs),
	headers = env.scanFiles("*.hxx", dirs),
	clamDependencies = clamDependencies,
	otherDependencies = otherDependencies,
	)

install += [
	env.Install(os.path.join(env['prefix'],'share','networkeditor','example-data'), examples)
	]

env.Alias('install', install)
env.Default(default)

=== plugins/MIDI/SConstruct ===
#! /usr/bin/python

import os, glob, sys

moduleName='midi'
version = "1.4.0"
description = "MIDI utilities for the CLAM framework"
url = 'http://clam-project.org'
clamDependencies = [
	'clam_core',
	'clam_audioio',
	'clam_processing',
	]
otherDependencies = [
	]

options = Variables('options.cache', ARGUMENTS)
options.Add(PathVariable('clam_prefix', 'The prefix where CLAM was installed', '/usr/local'))
options.Add(BoolVariable('verbose', 'Display the full command line', 'no') )
options.Add(PathVariable('prefix', 'Installation prefix (normally /usr, by default this is clam_prefix)', "", validator=PathVariable.PathAccept))
options.Add(PathVariable('prefix_for_packaging', 'Install location when packaging. Use "." for same as prefix.', '.'))
options.Add(BoolVariable('crossmingw', 'Using MinGW crosscompiler mode', 'no') )

toolChain = 'default'
if sys.platform == "win32": toolChain = 'mingw'
env = Environment(ENV=os.environ, tools=[toolChain], options=options)
options.Save('options.cache', env)
Help(options.GenerateHelpText(env))
env.SConsignFile() # Single signature file

CLAMInstallDir = env['clam_prefix']
if not env['prefix'] : env['prefix'] = env['clam_prefix']
#TODO: CHECK THIS
if env['prefix_for_packaging'] == '.' : env['prefix_for_packaging'] = env['prefix']

clam_sconstoolspath = os.path.join(CLAMInstallDir,'share','clam','sconstools')
if not os.access(os.path.join(clam_sconstoolspath,"clam.py"),os.R_OK):
	raise Exception("CLAM not installed at '%s'. Use clam_prefix option."%CLAMInstallDir)
if env['crossmingw'] :
	env.Tool('crossmingw', toolpath=[clam_sconstoolspath])
env.Tool('clam', toolpath=[clam_sconstoolspath])
env.EnableClamModules(clamDependencies, CLAMInstallDir)

# Sources and headers
sourcePaths = env.recursiveDirs(".")
sources = env.scanFiles('*.cxx', sourcePaths)
sources = dict.fromkeys(sources).keys()
headers = env.scanFiles('*.hxx', sourcePaths)
env.AppendUnique(CPPPATH=sourcePaths)
env.Append( CCFLAGS=['-g','-O3','-Wall'] )
if sys.platform == 'win32' or env['crossmingw'] :
	env.Append( CPPDEFINES=['__WINDOWS_MM__'] )
	env.Append( LIBS=['pthread', 'winmm'] )
elif sys.platform=='linux2' :
	env.Append( CPPDEFINES=['__LINUX_ALSASEQ__'] )
	env.Append( LIBS=['pthread', 'asound'] )
if sys.platform=='darwin' :
	env.Append( FRAMEWORKS=['CoreMIDI','CoreFoundation','CoreAudio'] )

install, default = env.ClamModule(
	moduleName,
	version,
	description = description,
	url = url,
	sources = sources,
	headers = headers,
	clamDependencies = clamDependencies,
	otherDependencies = otherDependencies,
	)


env.Alias('install', install)
env.Default(default)

=== plugins/continuousExcitationSynthesizer/SConstruct ===
#!/usr/bin/env python
import os, glob, sys

moduleName='continuous_excitation_synth'
version = "1.4.0"
description = "Continuous excitation instrument synthesizer for the CLAM framework"
url = 'http://clam-project.org'
clamDependencies = [
	'clam_core',
	'clam_audioio',
	'clam_processing',
	]
otherDependencies = [
	]

options = Variables('options.cache', ARGUMENTS)
options.Add(PathVariable('clam_prefix', 'The prefix where CLAM was installed', '/usr/local'))
options.Add(PathVariable('prefix', 'Installation prefix (normally /usr, by default this is clam_prefix)', "", validator=PathVariable.PathAccept))
options.Add(PathVariable('prefix_for_packaging', 'Install location when packaging. Use "." for same as prefix.', '.'))
options.Add(BoolVariable('verbose', 'Display the full command line', 'no') )
options.Add(BoolVariable('crossmingw', 'Using MinGW crosscompiler mode', 'no') )

toolChain = 'mingw' if sys.platform == "win32" else 'default'
env = Environment(ENV=os.environ, tools=[toolChain], options=options)
options.Save('options.cache', env)
Help(options.GenerateHelpText(env))
env.SConsignFile() # Single signature file

CLAMInstallDir = env['clam_prefix']
if not env['prefix'] : env['prefix'] = env['clam_prefix']

clam_sconstoolspath = os.path.join(CLAMInstallDir,'share','clam','sconstools')
if not os.access(os.path.join(clam_sconstoolspath,"clam.py"),os.R_OK):
	raise Exception("CLAM not installed at '%s'. Use clam_prefix option."%CLAMInstallDir)
if env['crossmingw'] :
	env.Tool('crossmingw', toolpath=[clam_sconstoolspath])
env.Tool('clam', toolpath=[clam_sconstoolspath])
env.EnableClamModules(clamDependencies, CLAMInstallDir)

isWindowsPlatform = sys.platform=="win32" or env['crossmingw']

env.Append( CCFLAGS=['-g','-O3','-Wall'] )

# Sources and headers
mainSources = {
	'ContinuousExcitationSynthesizer': os.path.join('.','ContinuousExcitationSynthesizer.cxx'),
#	'TestAudioDatabaseReader': os.path.join('toreview','TestAudioDatabaseReader.cxx'),
#	'EbowSynthesizer': os.path.join('toreview','ebowSynthesizer.cxx'),
}
sourcePaths = ["."]
sources = env.scanFiles('*.cxx', sourcePaths,
	)
print sources, mainSources.values()
headers = env.scanFiles('*.hxx', sourcePaths)
env.AppendUnique(CPPPATH=sourcePaths)

if sys.platform=="darwin" : #TODO fix. should be available in clamlibs pc
	env.Append( LIBPATH=['/opt/local/lib'] )
	env.Append( LIBS=['fftw3'] )

#if isWindowsPlatform :
#        env.AppendUnique(LINKFLAGS=['-Wl,--export-all-symbols'])

for binary, mainSource in mainSources.items() :
	sources.remove(mainSource)
envProgram = env.Clone()
envProgram.Prepend(LIBPATH=["."])
envProgram.AppendUnique(LIBS=["clam_"+moduleName])
programs = [ envProgram.Program(target=program, source = [mainSource])
	for program, mainSource in mainSources.items()]

install, default = env.ClamModule(
	moduleName,
	version,
	description = description,
	url = url,
	sources = sources,
	headers = headers,
	clamDependencies = clamDependencies,
	otherDependencies = otherDependencies,
	)

examples = env.scanFiles('*.clamnetwork', ".")

# TODO: Execute that command as part of the scons
# help2man -N -n 'OSC controlled synthesizer based on Spectral Modelling techniques' ./ContinuousExcitationSynthesizer > ContinuousExcitationSynthesizer.1
manpages = [ program+".1" for program in mainSources.keys() ]

install+= [
	env.Install(os.path.join(env['prefix'],'bin'), programs),
	env.Install(os.path.join(env['prefix'],'share','networkeditor','example-data'), examples),
	env.Install(os.path.join(env['prefix'],'share','man','man1'), manpages),
	]
env.Alias('install', install)
env.Default(programs, default)

=== plugins/expression/SConstruct ===
#!/usr/bin/env python
import os, glob, sys

moduleName='expression'
libraryName='clam_'+moduleName
version = "1.4.0"
description = "Experimental expression compiler for CLAM framework"
url = 'http://clam-project.org'
clamDependencies = [
	'clam_core',
	'clam_processing',
	]
otherDependencies = [
	]

options = Variables('options.cache', ARGUMENTS)
options.Add(PathVariable('clam_prefix', 'The prefix where CLAM was installed', '/usr/local'))
options.Add(PathVariable('prefix', 'Installation prefix (normally /usr, by default this is clam_prefix)', "", validator=PathVariable.PathAccept))
options.Add(BoolVariable('verbose', 'Display the full command line', 'no') )
options.Add(PathVariable('sandbox_path', 'Path where third party libraries were installed (in windows)', "", validator=PathVariable.PathAccept))
options.Add(BoolVariable('crossmingw', 'Using MinGW crosscompiler mode', 'no') )
toolChain = 'default'
if sys.platform == "win32": toolChain = 'mingw'
env = Environment(ENV=os.environ, tools=[toolChain], options=options)
options.Save('options.cache', env)
Help(options.GenerateHelpText(env))
env.SConsignFile() # Single signature file

CLAMInstallDir = env['clam_prefix']
if not env['prefix'] : env['prefix'] = env['clam_prefix']

clam_sconstoolspath = os.path.join(CLAMInstallDir,'share','clam','sconstools')
if not os.access(os.path.join(clam_sconstoolspath,"clam.py"),os.R_OK):
	raise Exception("CLAM not installed at '%s'. Use clam_prefix option."%CLAMInstallDir)
if env['crossmingw'] :
	env.Tool('crossmingw', toolpath=[clam_sconstoolspath])
env.Tool('clam', toolpath=[clam_sconstoolspath])
env.EnableClamModules(clamDependencies, CLAMInstallDir)

# Sources and headers
sourcePaths = env.recursiveDirs("mini")
sources = env.scanFiles('*.cxx', sourcePaths) + env.scanFiles('*.cpp', sourcePaths)
sources = dict.fromkeys(sources).keys()
headers = env.scanFiles('*.hxx', sourcePaths) + env.scanFiles('*.hpp', sourcePaths)
env.AppendUnique(CPPPATH=sourcePaths)

env.Append( CCFLAGS=['-O3','-Wall','-g'] )

sources = [s for s in sources if "main.cpp" not in s]
sources += ["ControlExpression.cxx"]
headers += ["ControlExpression.hxx"]

install, default = env.ClamModule(
	moduleName,
	version,
	description = description,
	url = url,
	sources = sources,
	headers = headers,
	clamDependencies = clamDependencies,
	otherDependencies = otherDependencies,
	)

env.Alias('install', install)
env.Default(default)

=== plugins/osc/SConstruct ===
#!/usr/bin/env python
import os, glob, sys, subprocess

moduleName='osc'
libraryName='clam_'+moduleName
version = "1.4.0"
description = "Experimental OSC support for the CLAM framework"
url = 'http://clam-project.org'
clamDependencies = [
	'clam_core',
	'clam_processing',
	'clam_sndfile',
	]
otherDependencies = [
	]

options = Variables('options.cache', ARGUMENTS)
options.Add(PathVariable('clam_prefix', 'The prefix where CLAM was installed', ''))
options.Add(BoolVariable('verbose', 'Display the full command line', 'no') )
options.Add(PathVariable('prefix', 'Installation prefix (normally /usr, by default this is clam_prefix)', "", validator=PathVariable.PathAccept))
options.Add(PathVariable('prefix_for_packaging', 'Install location when packaging. Use "." for same as prefix.', '.'))
options.Add(PathVariable('sandbox_path', 'Path where third party libraries were installed (in windows)', "", validator=PathVariable.PathAccept))
if sys.platform=='linux2' :
	options.Add(BoolVariable('crossmingw', 'Using MinGW crosscompiler mode', 'no') )

toolChain = 'default'
if sys.platform == "win32": toolChain = 'mingw'
env = Environment(ENV=os.environ, tools=[toolChain], options=options)
options.Save('options.cache', env)
Help(options.GenerateHelpText(env))
env.SConsignFile() # Single signature file

CLAMInstallDir = env['clam_prefix']
if not env['prefix'] : env['prefix'] = env['clam_prefix']
#TODO: CHECK THIS
if env['prefix_for_packaging'] == '.' : env['prefix_for_packaging'] = env['prefix']

clam_sconstoolspath = os.path.join(CLAMInstallDir,'share','clam','sconstools')
if not os.access(os.path.join(clam_sconstoolspath,"clam.py"),os.R_OK):
	raise Exception("CLAM not installed at '%s'. Use clam_prefix option."%CLAMInstallDir)
if env['crossmingw'] :
	env.Tool('crossmingw', toolpath=[clam_sconstoolspath])
env.Tool('clam', toolpath=[clam_sconstoolspath])
env.EnableClamModules(clamDependencies, CLAMInstallDir)

# Sources and headers
sourcePaths = ["."]
sources = env.scanFiles('*.cxx', sourcePaths) + env.scanFiles('*.c', sourcePaths)
sources = dict.fromkeys(sources).keys()
headers = env.scanFiles('*.hxx', sourcePaths) + env.scanFiles('*.h', sourcePaths)
env.AppendUnique(CPPPATH=sourcePaths)

if subprocess.call("pkg-config --atleast-version=0.26 liblo",shell=True)==0:
	env.Append( LIBPATH=['/usr/local/lib'] )
	env.Append( CPPDEFINES=['__MULTICAST_LIBLO__'] )
env.ParseConfig('pkg-config --cflags --libs liblo')

if sys.platform=="darwin" : #TODO fix. should be available in clamlibs pc
	env.Append( LIBPATH=['/opt/local/lib'] )
	env.Append( LIBS=['fftw3'] )

# TODO: All this (but the ws2_32 in windows) can be retrieved from pkg-config
if env['sandbox_path'] :
	env.Append( CPPPATH=os.path.join(env['sandbox_path'],'local/include') )
	env.Append( LIBPATH=os.path.join(env['sandbox_path'],'local/lib') )
	env.Append( LIBS=['ws2_32'] )
	env.Append( LIBS=['pthread'] )
	env.ParseConfig('PKG_CONFIG_PATH=%s pkg-config --cflags --libs sndfile'%os.path.join(env['sandbox_path'],'local','lib','pkgconfig'))

env.Append( CCFLAGS=['-g','-O3','-Wall'] )

install, default = env.ClamModule(
	moduleName,
	version,
	description = description,
	url = url,
	sources = sources,
	headers = headers,
	clamDependencies = clamDependencies,
	otherDependencies = otherDependencies,
	)

env.Alias('install', install)
env.Default(*default)

=== plugins/resampling/SConstruct ===
#!/usr/bin/env python
import os, glob, sys

moduleName='resampling'
version = "1.4.0"
description = "Experimental resample wrapper for the CLAM framework"
url = 'http://clam-project.org'
clamDependencies = [
	'clam_core',
	'clam_audioio',
	'clam_processing',
	]
otherDependencies = [
	]

options = Variables('options.cache', ARGUMENTS)
options.Add(PathVariable('clam_prefix', 'The prefix where CLAM was installed', '/usr/local'))
options.Add(PathVariable('prefix', 'Installation prefix (normally /usr, by default this is clam_prefix)', "", validator=PathVariable.PathAccept))
options.Add(PathVariable('prefix_for_packaging', 'Install location when packaging. Use "." for same as prefix.', '.'))
options.Add(BoolVariable('verbose', 'Display the full command line', 'no') )
options.Add(PathVariable('sandbox_path', 'Path where third party libraries were installed (in windows)', "", validator=PathVariable.PathAccept))
options.Add(BoolVariable('crossmingw', 'Using MinGW crosscompiler mode', 'no') )
toolChain = 'mingw' if sys.platform == "win32" else 'default'
env = Environment(ENV=os.environ, tools=[toolChain], options=options)
options.Save('options.cache', env)
Help(options.GenerateHelpText(env))
env.SConsignFile() # Single signature file

CLAMInstallDir = env['clam_prefix']
if not env['prefix'] : env['prefix'] = env['clam_prefix']
#TODO: CHECK THIS
if env['prefix_for_packaging'] == '.' : env['prefix_for_packaging'] = env['prefix']

clam_sconstoolspath = os.path.join(CLAMInstallDir,'share','clam','sconstools')
if not os.access(os.path.join(clam_sconstoolspath,"clam.py"),os.R_OK):
	raise Exception("CLAM not installed at '%s'. Use clam_prefix option."%CLAMInstallDir)
if env['crossmingw'] :
	env.Tool('crossmingw', toolpath=[clam_sconstoolspath])
env.Tool('clam', toolpath=[clam_sconstoolspath])
env.EnableClamModules(clamDependencies, CLAMInstallDir)

sources = glob.glob('*.cxx')
headers = glob.glob('*.hxx')

env.ParseConfig( "pkg-config --cflags --libs samplerate" )
env.Append( CCFLAGS=['-g','-O3','-Wall'] )

install, default = env.ClamModule(
	moduleName,
	version,
	description = description,
	url = url,
	sources = sources,
	headers = headers,
	clamDependencies = clamDependencies,
	otherDependencies = otherDependencies,
	)

env.Alias('install', install)
env.Default(default)

=== plugins/samplebysample/SConstruct ===
#!/usr/bin/env python
import os, glob, sys

moduleName='samplebysample'
version = "1.4.0"
description = "Sample by sample processing for the CLAM framework"
url = 'http://clam-project.org'
clamDependencies = [
	'clam_core',
	'clam_audioio',
	'clam_processing',
	]
otherDependencies = [
	]

options = Variables('options.cache', ARGUMENTS)
options.Add(PathVariable('clam_prefix', 'The prefix where CLAM was installed', '/usr/local'))
options.Add(PathVariable('prefix', 'Installation prefix (normally /usr, by default this is clam_prefix)', "", validator=PathVariable.PathAccept))
options.Add(PathVariable('prefix_for_packaging', 'Install location when packaging. Use "." for same as prefix.', '.'))
options.Add(BoolVariable('verbose', 'Display the full command line', 'no') )
options.Add(PathVariable('sandbox_path', 'Path where third party libraries were installed (in windows)', "", validator=PathVariable.PathAccept))
options.Add(BoolVariable('crossmingw', 'Using MinGW crosscompiler mode', 'no') )
toolChain = 'mingw' if sys.platform == "win32" else 'default'
env = Environment(ENV=os.environ, tools=[toolChain], options=options)
options.Save('options.cache', env)
Help(options.GenerateHelpText(env))
env.SConsignFile() # Single signature file

CLAMInstallDir = env['clam_prefix']
if not env['prefix'] : env['prefix'] = env['clam_prefix']

clam_sconstoolspath = os.path.join(CLAMInstallDir,'share','clam','sconstools')
if not os.access(os.path.join(clam_sconstoolspath,"clam.py"),os.R_OK):
	raise Exception("CLAM not installed at '%s'. Use clam_prefix option."%CLAMInstallDir)
if env['crossmingw'] :
	env.Tool('crossmingw', toolpath=[clam_sconstoolspath])
env.Tool('clam', toolpath=[clam_sconstoolspath])
env.EnableClamModules(clamDependencies, CLAMInstallDir)

sourcePaths = ["src"]
sources = env.scanFiles('*.cxx', sourcePaths)
sources = dict.fromkeys(sources).keys()
headers = env.scanFiles('*.hxx', sourcePaths)
env.Append( CCFLAGS=['-g','-O3','-Wall'] )

if sys.platform=="darwin" : #TODO fix. should be available in clamlibs pc
	env.Append( LIBPATH=['/opt/local/lib'] )
if sys.platform=="win32" or 'crossmingw' in env['TOOLS'] :
	env.Append( LIBPATH=[os.path.join(env['sandbox_path'],'local','lib')] )

install, default = env.ClamModule(
	moduleName,
	version,
	description = description,
	url = url,
	sources = sources,
	headers = headers,
	clamDependencies = clamDependencies,
	otherDependencies = otherDependencies,
	)

examples = env.scanFiles('*.clamnetwork', ['example-data'])
examples+= env.scanFiles('*.ui', ['example-data'])

install+= [
	env.Install(os.path.join(env['prefix'],'share','networkeditor','example-data'), examples)
	]

env.Alias('install', install)
env.Default(default)

=== plugins/sndfile/SConstruct ===
#!/usr/bin/env python
import os, glob, sys

moduleName='sndfile'
version = "1.4.0"
description = "Experimental SndFile wrapper for the CLAM framework"
url = 'http://clam-project.org'
clamDependencies = [
	'clam_core',
	]
otherDependencies = [
	]

options = Variables('options.cache', ARGUMENTS)
options.Add(PathVariable('clam_prefix', 'The prefix where CLAM was installed', '/usr/local'))
options.Add(PathVariable('prefix', 'Installation prefix (normally /usr, by default this is clam_prefix)', "", validator=PathVariable.PathAccept))
options.Add(PathVariable('prefix_for_packaging', 'Install location when packaging. Use "." for same as prefix.', '.'))
options.Add(BoolVariable('verbose', 'Display the full command line', 'no') )
options.Add(PathVariable('sandbox_path', 'Path where third party libraries were installed (in windows)', "", validator=PathVariable.PathAccept))
options.Add(BoolVariable('crossmingw', 'Using MinGW crosscompiler mode', 'no') )
toolChain = 'default'
if sys.platform == "win32": toolChain = 'mingw'
env = Environment(ENV=os.environ, tools=[toolChain], options=options)
options.Save('options.cache', env)
Help(options.GenerateHelpText(env))
env.SConsignFile() # Single signature file

CLAMInstallDir = env['clam_prefix']
if not env['prefix'] : env['prefix'] = env['clam_prefix']
#TODO: CHECK THIS
if env['prefix_for_packaging'] == '.' : env['prefix_for_packaging'] = env['prefix']

clam_sconstoolspath = os.path.join(CLAMInstallDir,'share','clam','sconstools')
if not os.access(os.path.join(clam_sconstoolspath,"clam.py"),os.R_OK):
	raise Exception("CLAM not installed at '%s'. Use clam_prefix option."%CLAMInstallDir)
if env['crossmingw'] :
	env.Tool('crossmingw', toolpath=[clam_sconstoolspath])
env.Tool('clam', toolpath=[clam_sconstoolspath])
env.EnableClamModules(clamDependencies, CLAMInstallDir)

# Sources and headers
sourcePaths = env.recursiveDirs(".")
sources = env.scanFiles('*.cxx', sourcePaths) + env.scanFiles('*.c', sourcePaths)
sources = dict.fromkeys(sources).keys()
headers = env.scanFiles('*.hxx', sourcePaths) + env.scanFiles('*.h', sourcePaths)
env.AppendUnique(CPPPATH=sourcePaths)
if sys.platform == "win32" or env['crossmingw'] :
	env.AppendUnique(LIBS=['pthread'])
if not env.has_key("PKG_CONFIG") :
	env['PKG_CONFIG'] = 'pkg-config'
env.ParseConfig( "$PKG_CONFIG --cflags --libs sndfile" )
env.Append( CCFLAGS=['-g','-O3','-Wall'] )

install, default = env.ClamModule(
	moduleName,
	version,
	description = description,
	url = url,
	sources = sources,
	headers = headers,
	clamDependencies = clamDependencies,
	otherDependencies = otherDependencies,
	)

env.Alias('install', install)
env.Default(default)

=== debian/changelog ===
clam (1.3.1~svn12860-1ubuntu1) jaunty; urgency=low

  * CLAM/debian/watch: pointed to clam-X.Y.Z instead of CLAM-X.Y.Z
  * CLAM/debian/watch: debian uupdate parameters added

 -- CLAM Team <developers@clam-project.org>  Thu, 11 Jun 2009 20:55:01 +0200

clam (1.3.1~svn12860-1) unstable; urgency=low

  * CLAM/debian/libclam-doc.examples: avoiding duplicate examples/examples dir
  * CLAM/debian/rules: not tarbalizing doxygen and examples
  * CLAM/debian/rules: removed traces of plugin installation which is in a
    different src package now
  * CLAM/debian/libclam-doc.examples/docs: Doxygen is docs while examples are
    examples
  * CLAM/debian/libclam-doc.examples/docs: Taking folders instead of the
    tarballs
  * CLAM/debian/changelog: updated.
  * CLAM/debian/control: not depending on libxerces28-dev as this makes lintian
    complain even being one of many alternatives
  * Updated the new website to http://clam-project.org
  * debian specific files not part of upstream tarball
  * Added David García Garzón as Uploader

 -- CLAM Team <developers@clam-project.org>  Wed, 04 Mar 2009 21:45:40 +0100

clam (1.3.1~svn12519-1) unstable; urgency=low

  * New upstream release.
  * Not built as a native package anymore.
  * Examples and doxygen are not tarballed but provided as independent files.
  * Setting the distribution to unstable.

 -- CLAM Team <clam@iua.upf.edu>  Tue, 23 Dec 2008 09:09:56 +0100

clam (1.3.0-1) unstable; urgency=low

  * New upstream release
  * Paul Brossier changes:
    * debian/control: added myself to Uploaders, use 
    * debian/control: added Vcs-Browser and Vcs-Svn fields
    * debian/rules: add verbose=1 option
    * debian/: set svn-bp properties

  * Python dependency required for libclam-dev
  * debian/rules: install_prefix -> prefix_for_packaging
  * debian/rules: Adapted to new configure way (any option means configure and stop)
  * debian/rules: configure needs the target dir to be created
  * removed osc dependencies
  * debian/control: fftw3 -> libfftw3
  * temptative compilation of plugins within the debian package
  * fix on debian/rules to compile plugins, lets try again!
  * debian/rules: hack to make scons -c work (complained about non existing clam prefix)
  * debian/rules: Removed the code to compile plugins.
  * /debian/control: Standards version upgrade
  * debian/menu: 'Apps' deprecated in favor of Applications
  * debian/control: Changed the mainainer email to match the one in the build script
  * debian rules files updated because the rename of the Guitar plugin
  * debian/control: added alternative dependency to libxerces-c2-dev
  * debian/control: matching the soname number 13
  * CLAM/debian/control: description: -dev file is no more a metapackage.
  * CLAM/debian/control: description refers to libclam-XXXX instead of clam-XXX
  * CLAM/debian/control: description: libclam does not contain development files,
   libclam-dev do
  * debian/libclam0.install renamed as debian/libclam13.install
  * debian/rules: updated to the libclam13 name
  * debian/control: removed hard version dependency from the examples
    packages to the binary ones to enable binary Non-Maintainer-Updates.

 -- CLAM Team <clam@iua.upf.edu>  Tue, 23 Dec 2008 09:08:27 +0100

clam (1.1.1~svn11102-1) unstable; urgency=low

  * Build of current trunk based on latest svn snapshot

 -- Paul Brossier <piem@debian.org>  Tue, 29 Jan 2008 16:15:23 +0100

clam (1.0.1-1) unstable; urgency=low

  * debian/rules: Updated to follow Sconstruct changes (changed location and removed vmqt module)

 -- Giulio Paci <giuliopaci@interfree.it>  Sat,  7 Apr 2007 15:06:32 +0200

clam (0.99.0-1) feisty; urgency=low

  * debian/control: python dependency required for libclam-dev
  * debian/rules,control: Enabling portaudio and fftw3
  * Paul Brossier contributed changes:
    * debian/watch: add debian watch file, to use with uscan. please update tarball names (e.g. clam-0.99.tar.gz)
    * debian/rules: do not use QTDIR
    * debian/copyright: add download url
    * debian/rules: fix typo in SCONS_ENV
    * debian/dirs: remove dirs file (nothing in /usr/*bin and *.install files do the work)
    * debian/rules: always use the same scons options, remove blank lines, move scons configure to configure rules
    * debian/rules: remove commented lines from dh_make template
    * debian/*.install: add install files, use dh_install --sourcedir=debian/tmp
    * debian/rules: make use of dh_installdocs to install files in /u/s/d/libclam-doc
    * debian/*.ex: deleted useless dh_make templates
    * debian/control: add Section: libs to source package
    * debian/rules: make sure we build with alsa, and not with portaudio, clean cleaner

 -- CLAM Team <clam@iua.upf.edu>  Fri,  9 Feb 2007 14:01:51 +0100

clam (0.98.0-1) feisty; urgency=low

  * New upstream release 
  * libclam_vmfl is not included any more.
  * debian/rules simplified: removed redundant "rm" commands 
  * lintian advice: Added dependency to python
  * lintian advice: scons/sconstools/addDependentLibsToBundle.py is not
    installed

 -- CLAM Team <clam@iua.upf.edu>  Fri,  9 Feb 2007 14:01:51 +0100

clam (0.97.0-1) unstable; urgency=low

  * Collapsed multiple libclam-* packages in libclam0 and libclam-dev
  * Disabled doxygen source browsing to reduce libclam-doc size
  * Added conflict with old splitted clam packages

 -- CLAM Team <clam@iua.upf.es>  Sat, 30 Dec 2006 10:22:34 +0100
 

clam (0.96.0-1) unstable; urgency=low

  * New upstream release

 -- CLAM Team <clam@iua.upf.es>  Wed, 22 Dec 2006 10:22:34 +0100

clam (0.95.0-1) unstable; urgency=low

  * New upstream release

 -- CLAM Team <clam@iua.upf.es>  Wed, 22 Nov 2006 10:22:34 +0100

clam (0.91.0-1) unstable; urgency=low

  * New upstream release
  * Package descriptions updated
  * Added interdependencies for libclamX packages
  * Proper sections (libdev -> libdevel)
  * Removed xlib-dev that is no more in xorg
  * Removed versions on most build deps so they have not to be


=== debian/control ===
Source: clam
Section: libs
Priority: optional
Maintainer: CLAM Team <developers@clam-project.org>
Uploaders: David García Garzón <dgarcia_debian@iua.upf.edu>
Standards-Version: 3.9.1
Homepage: http://clam-project.org/
Vcs-Browser: https://clam-project.org/clam/trunk/packaging/CLAM/debian
Vcs-Svn: https://clam-project.org/clam/trunk/packaging/CLAM/debian
Build-Depends:
	debhelper (>= 5.0.0), 
	scons,
	ladspa-sdk,
	lv2core,
	libxerces-c-dev,
	portaudio19-dev,
	libfftw3-dev,
	libjack-dev,
	libmad0-dev,
	libogg-dev,
	libsndfile1-dev,
	libvorbis-dev,
	libid3-3.8.3-dev,
	libasound2-dev,
	liblo0-dev,
	doxygen,
	python-central

Package: libclam1.4
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Conflicts:
 libclam-audioio-dev,
 libclam-audioio0,
 libclam-core-dev,
 libclam-core0,
 libclam-processing-dev,
 libclam-processing0,
 libclam-vmfl-dev,
 libclam-vmfl0,
 libclam-vmqt-dev,
 libclam-vmqt0
Suggests:
 clam-annotator,
 clam-networkeditor,
 clam-smstools,
 libclam-plugins1.4,
 clam-chordata
Description: CLAM framework - runtime libraries
 CLAM is a framework to develop audio and music applications in C++.
 It provides tools to perform advanced analysis, transformations and synthesis,
 visualization for audio and music related objects, and other tools that are
 useful to abstract target platform for most tasks in an audio applications
 such as audio devices, file formats, threading...
 . 
 This package contains the shared libraries for libclam-core, 
 libclam-processing and libclam-audioio.

Package: libclam1.4-dev
Section: libdevel
Architecture: any
Depends:
 libclam1.4 (= ${binary:Version}),
 ladspa-sdk (>= 1.1),
 pkg-config (>= 0.15),
 portaudio19-dev,
 libfftw3-dev | fftw3-dev,
 libmad0-dev (>= 0.15.1b),
 libogg-dev (>= 1.1.2),
 libsndfile1-dev (>= 1.0.2-1),
 libvorbis-dev (>= 1.0.1),
 libid3-3.8.3-dev,
 libasound2-dev (>= 1.0.8),
 liblo0-dev,
 libjack-dev,
 scons,
 ${python:Depends},
 ${misc:Depends}
Provides: libclam-dev
Conflicts: libclam-dev
Suggests: libclam-doc (= ${binary:Version})
Recommends: libclam-tools (= ${binary:Version}), clam-plugins
Description: CLAM framework - development files
 CLAM is a framework to develop audio and music applications in C++.
 It provides tools to perform advanced analysis, transformations and synthesis,
 visualization for audio and music related objects, and other tools that are
 useful to abstract target platform for most tasks in an audio applications
 such as audio devices, file formats, threading...
 . 
 This package contains the files needed to develop with libclam-core,
 libclam-processing, and libclam-audioio libraries.

Package: libclam1.4-dbg
Architecture: any
Section: debug
Priority: extra
Depends: libclam1.4 (= ${binary:Version}), ${misc:Depends}
Description: CLAM framework - runtime libraries debug symbols
 CLAM is a framework to develop audio and music applications in C++.
 It provides tools to perform advanced analysis, transformations and synthesis,
 visualization for audio and music related objects, and other tools that are
 useful to abstract target platform for most tasks in an audio applications
 such as audio devices, file formats, threading...
 .
 This package contains the debug symbols for libclam-core,
 libclam-processing, and libclam-audioio libraries.

Package: libclam-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Description: CLAM framework - documentation
 CLAM is a framework to develop audio and music applications in C++.
 It provides tools to perform advanced analysis, transformations and synthesis,
 visualization for audio and music related objects, and other tools that are
 useful to abstract target platform for most tasks in an audio applications
 such as audio devices, file formats, threading...
 .
 This package contains the framework documentation and some example programs.

Package: clam-tools
Section: sound
Architecture: all
Depends: ${python:Depends}, ${misc:Depends}
XS-Python-Version: all
XB-Python-Version: ${python:Version} 
Description: CLAM framework - tools
 CLAM is a framework to develop audio and music applications in C++.
 It provides tools to perform advanced analysis, transformations and synthesis,
 visualization for audio and music related objects, and other tools that are
 useful to abstract target platform for most tasks in an audio applications
 such as audio devices, file formats, threading...
 .
 This package installs some python utilities.
  * clamrefactor - Performs batch modification on networks' xml,
    often used by version migration scripts.
  * clamnetwork2code - Generates C++ code from a network xml file
  * clam_lv2_generator - Helper script to generate lv2 related files.

=== plugins/debian/control ===
Source: clam-plugins
Section: sound
Priority: optional
Maintainer: CLAM Team <developers@clam-project.org>
Uploaders: David García Garzón <dgarcia_debian@iua.upf.edu>
Homepage: http://clam-project.org
Build-Depends:
 debhelper (>= 5.0.0),
 scons,
 libclam-dev,
 liblo0-dev
Standards-Version: 3.9.1

Package: libclam-plugins1.4
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends} 
Provides: libclam-plugins, clam-plugin
Conflicts: libclam-plugins
Recommends: clam-networkeditor
Description: CLAM framework plugins
 CLAM is a framework to develop audio and music applications in C++.
 It provides tools to perform advanced analysis, transformations and synthesis,
 visualization for audio and music related objects, and other tools that are
 useful to abstract target platform for most tasks in an audio applications
 such as audio devices, file formats, threading...
 .
 This package provides several plugins extensions for the CLAM audio
 framework, which are already provided by the CLAM project including:
  * OSC support
  * Real-time 3D acoustics scene simulation (ambisonics, raytracing, HRTF's)
  * Speech synthesis and analysis
  * Simple SMS based synthesizer
  * Guitar effects
  * Sample by sample convolution effects
  * Lock-free wave file reader

Package: libclam-plugins1.4-dev
Architecture: any
Section: libdevel
Depends:  ${shlibs:Depends}, ${misc:Depends}, libclam1.4-dev, libclam-plugins1.4 (= ${binary:Version})
Description: CLAM framework plugins - development files
 CLAM is a framework to develop audio and music applications in C++.
 It provides tools to perform advanced analysis, transformations and synthesis,
 visualization for audio and music related objects, and other tools that are
 useful to abstract target platform for most tasks in an audio applications
 such as audio devices, file formats, threading...
 .
 This package provides development files needed to compile C++ code referring
 specific symbols in libclam-plugins. This package is not required to use
 plugins as long as the processing object defined in them are created by means
 of factories and manipulated using the abstract interfaces in libclam-core.
 
Package: libclam-plugins1.4-dbg
Architecture: any
Section: debug
Priority: extra
Depends: libclam-plugins1.4 (= ${binary:Version}), ${misc:Depends}
Description: CLAM framework plugins - debug symbols
 CLAM is a framework to develop audio and music applications in C++.
 It provides tools to perform advanced analysis, transformations and synthesis,
 visualization for audio and music related objects, and other tools that are
 useful to abstract target platform for most tasks in an audio applications
 such as audio devices, file formats, threading...
 .
 This package contains the debug symbols for the extension plugins
 provided by the CLAM project.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1




SCONS_OPTIONS= prefix_for_packaging=$(CURDIR)/debian/tmp/usr prefix=/usr xmlbackend=xercesc release=yes double=0 with_fftw3=yes with_fftw=no verbose=1
SCONS= scons


configure: configure-stamp
configure-stamp:
	dh_testdir
	mkdir -p $(CURDIR)/debian/tmp/usr
	cd $(CURDIR); $(SCONS) configure $(SCONS_OPTIONS)
	touch configure-stamp


build: build-stamp
build-stamp: configure-stamp 
	dh_testdir
	cd $(CURDIR); $(SCONS) core processing audioio
	doxygen $(CURDIR)/doxygen.cfg
	touch build-stamp

clean:
	dh_testdir
	dh_testroot
	rm -f build-stamp configure-stamp
	-cd $(CURDIR) && $(SCONS) -c
	find $(CURDIR) -name .*sconf_temp* | xargs rm -rf
	find $(CURDIR) -type f -name *.pyc | xargs rm -rf
	find $(CURDIR) -type f -name *.o | xargs rm -rf
	find $(CURDIR) -type f -name *.os | xargs rm -rf
	find $(CURDIR) -type f -name *.a | xargs rm -rf
	find $(CURDIR) -type f -name .*.swp | xargs rm -rf
	find $(CURDIR) -type f -name .sconsign | xargs rm -rf
	find $(CURDIR) -type f -name *.db | xargs rm -rf
	find $(CURDIR) -type f -name flags.conf | xargs rm -rf
	find $(CURDIR) -type d -name generated | xargs rm -rf
	-rm -rf $(CURDIR)/CLAM.tag $(CURDIR)/*.tar.gz $(CURDIR)/doxygen \
	  $(CURDIR)/src/Defines/CLAMVersion.cxx src/Defines/CLAMVersion.hxx \
		$(CURDIR)/.sconsign.dblite config.log \
		$(CURDIR)/*/{*.conf,include,src,*.so*,*.pc,CLAM} \
	dh_clean 

install: build
	dh_testdir
	dh_testroot
	dh_clean -k 
	dh_installdirs
	mkdir -p $(CURDIR)/debian/tmp/usr
	cd $(CURDIR) && $(SCONS) install
	dh_install --sourcedir=debian/tmp --fail-missing

# Build architecture-independent files here.
binary-indep: build install
# We have nothing to do by default.

# Build architecture-dependent files here.
binary-arch: build install
	dh_testdir
	dh_testroot
	dh_installchangelogs CHANGES
	dh_installdocs
	dh_installexamples
	dh_installman
	dh_link
	dh_strip --dbg-package=libclam1.4-dbg
	dh_pycentral
	dh_compress
	dh_fixperms
	dh_makeshlibs
	dh_installdeb
	dh_shlibdeps -L libclam1.4 -l debian/libclam1.4/usr/lib
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install configure

=== plugins/debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1




CFLAGS = -Wall -g
SCONS_OPTIONS= prefix_for_packaging=$(CURDIR)/debian/tmp/usr prefix=/usr release=yes
SCONS= scons
PLUGINS=continuousExcitationSynthesizer spacialization GuitarEffects Filters samplebysample speech sndfile MIDI # osc

ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
	CFLAGS += -O0
else
	CFLAGS += -O2
endif
ifeq (,$(findstring nostrip,$(DEB_BUILD_OPTIONS)))
	INSTALL_PROGRAM += -s
endif

# shared library versions, option 1
version=2.0.5
major=2
# option 2, assuming the library is created as src/.libs/libfoo.so.2.0.5 or so
#version=`ls src/.libs/lib*.so.* | \
# awk '{if (match($$0,/[0-9]+\.[0-9]+\.[0-9]+$$/)) print substr($$0,RSTART)}'`
#major=`ls src/.libs/lib*.so.* | \
# awk '{if (match($$0,/\.so\.[0-9]+$$/)) print substr($$0,RSTART+4)}'`

configure: configure-stamp
configure-stamp:
	dh_testdir
	mkdir -p $(CURDIR)/debian/tmp/usr
#	cd $(CURDIR); $(SCONS) configure $(SCONS_OPTIONS)
	touch configure-stamp


build: build-stamp
build-stamp: configure-stamp 
	dh_testdir
	for plugin in $(PLUGINS); do cd $(CURDIR)/$$plugin; $(SCONS) clam_prefix=/usr prefix=$(CURDIR)/debian/tmp/usr; done
	touch build-stamp

clean:
	dh_testdir
	dh_testroot
	rm -f build-stamp configure-stamp
	for plugin in $(PLUGINS); do cd $(CURDIR)/$$plugin; $(SCONS) -c clam_prefix=/usr prefix=$(CURDIR)/debian/tmp/usr; done
	find $(CURDIR) -name .*sconf_temp* | xargs rm -rf
	find $(CURDIR) -type f -name *.pyc | xargs rm -rf
	find $(CURDIR) -type f -name *.o | xargs rm -rf
	find $(CURDIR) -type f -name *.os | xargs rm -rf
	find $(CURDIR) -type f -name *.so* | xargs rm -rf
	find $(CURDIR) -type f -name *.a | xargs rm -rf
	find $(CURDIR) -type f -name .*.swp | xargs rm -rf
	find $(CURDIR) -type f -name .sconsign | xargs rm -rf
	find $(CURDIR) -type f -name *.db | xargs rm -rf
	-rm -rf $(CURDIR)/*/.sconsign.dblite 
	dh_clean 

install: build
	dh_testdir
	dh_testroot
	dh_clean -k 
	dh_installdirs
	mkdir -p $(CURDIR)/debian/tmp/usr
	for plugin in $(PLUGINS); do cd $(CURDIR)/$$plugin; $(SCONS) install; done
	find $(CURDIR)/debian/tmp/usr
	dh_install --sourcedir=debian/tmp

# Build architecture-independent files here.
binary-indep: build install
# We have nothing to do by default.

# Build architecture-dependent files here.
binary-arch: build install
	dh_testdir
	dh_testroot
	dh_installchangelogs
	dh_installdocs
	dh_installexamples
	dh_installman
	dh_link
	dh_strip --dbg-package=libclam-plugins1.4-dbg
	dh_compress
	dh_fixperms
	dh_makeshlibs
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install configure

=== debian/watch ===
version=3
http://clam-project.org/download/src/svnsnapshots/index.html CLAM-(.*)\.tar\.gz debian uupdate
http://clam-project.org/download/src/index.html CLAM-(.*)\.tar\.gz debian uupdate
